=== debian/changelog ===
libcoap3 (4.3.0-2build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 10:07:28 +0100

libcoap3 (4.3.0-2) unstable; urgency=medium

  * [e1af96c] Rebuild patch queue from patchqueue branch
    Added patch: pkg-config-Don-t-use-hard-coded-binary.patch
    (Closes: #996652)

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 17 Oct 2021 09:18:09 +0200

libcoap3 (4.3.0-1) unstable; urgency=medium

  * [54d24e4] d/gbp.conf: Adjust to unstable
  * [d523e17] d/control: Update Standards-Version to 4.6.0
    No further changes needed.
  * [8dc446d] d/libcoap3.lintian-overrides: Small typo fixes
  * [21e33a3] d/libcoap3-bin.lintian-overrides: Catch up issue more generic

 -- Carsten Schoenert <c.schoenert@t-online.de>  Fri, 17 Sep 2021 20:45:39 +0200

libcoap3 (4.3.0-1~exp1) experimental; urgency=medium

  * [2648182] New upstream version 4.3.0
  * [0cc065f] Remove patch queue
    No need any more for a patch queue right now.
  * [6c00820] d/libcoap3.docs: Also install the file README
  * [e71020f] d/rules: Add new default configure options
  * [d316b54] d/rules: Don't remove all files named *Makefile
  * [a391b91] d/libcoap3-dev.doc: New sequencer to get examples installed
  * [3c70fd8] d/control: Adding Rules-Requires-Root entry
  * [3a0f766] d/libcoap3-bin.lintian-overrides: Ignore one advice

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 27 Jun 2021 09:21:15 +0200

libcoap3 (4.3.0~rc2-1) experimental; urgency=medium

  * initial packaging (Closes: #987417)
  * [afafa79] New upstream version 4.3.0~rc2

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 24 Apr 2021 08:50:07 +0200
