=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

opts="mode=git, \
      uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/, \
      dversionmangle=s/\+ds(\.?\d+)?$//" \
      https://github.com/obgm/libcoap.git \
         refs/tags/v(\d+\.\d+\.\d+(?:\.?beta[1-9])?)
