## libcoap3 4.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # CMakeLists.txt for libcoap
 #
 # Copyright (C) 2020 Carlos Gomes Martinho <carlos.gomes_martinho@siemens.com>
-# Copyright (C) 2020-2021 Jon Shallow <supjps-libcoap@jpshallow.com>
+# Copyright (C) 2020-2022 Jon Shallow <supjps-libcoap@jpshallow.com>
 #
 # SPDX-License-Identifier: BSD-2-Clause
 #
@@ -12,7 +12,7 @@
 
 project(
   libcoap
-  VERSION 4.3.0
+  VERSION 4.3.1
   LANGUAGES CXX C)
 
 set(LIBCOAP_API_VERSION 3)
@@ -58,6 +58,14 @@
   "compile with the tinydtls project in the submodule if on, otherwise try to find the compiled lib with find_package"
   ON)
 option(
+  ENABLE_CLIENT_MODE
+  "compile with support for client mode code"
+  ON)
+option(
+  ENABLE_SERVER_MODE
+  "compile with support for server mode code"
+  ON)
+option(
   WITH_EPOLL
   "compile with epoll support"
   ON)
@@ -92,6 +100,10 @@
 
 if(MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+endif()
+
+if(APPLE)
+  add_definitions(-D__APPLE_USE_RFC_3542=1)
 endif()
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_BINARY_DIR})
@@ -123,7 +135,6 @@
 check_include_file(pthread.h HAVE_PTHREAD_H)
 check_include_file(stdlib.h HAVE_STDINT_H)
 check_include_file(stdint.h HAVE_STDLIB_H)
-check_include_file(inttypes.h HAVE_INTTYPES_H)
 check_include_file(syslog.h HAVE_SYSLOG_H)
 check_include_file(sys/ioctl.h HAVE_SYS_IOCTL_H)
 check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
@@ -149,15 +160,30 @@
 check_function_exists(strnlen HAVE_STRNLEN)
 check_function_exists(strrchr HAVE_STRRCHR)
 check_function_exists(getrandom HAVE_GETRANDOM)
+check_function_exists(if_nametoindex HAVE_IF_NAMETOINDEX)
 
 # check for symbols
 if(WIN32)
   set(HAVE_STRUCT_CMSGHDR 1)
 else()
   check_symbol_exists(
-    cmsghdr
+    CMSG_FIRSTHDR
     sys/socket.h
     HAVE_STRUCT_CMSGHDR)
+endif()
+
+if(${ENABLE_CLIENT_MODE})
+  set(COAP_CLIENT_SUPPORT "1")
+  message(STATUS "compiling with client support")
+else()
+  message(STATUS "compiling without client support")
+endif()
+
+if(${ENABLE_SERVER_MODE})
+  set(COAP_SERVER_SUPPORT "1")
+  message(STATUS "compiling with server support")
+else()
+  message(STATUS "compiling without server support")
 endif()
 
 if(${WITH_EPOLL}
@@ -353,8 +379,35 @@
 
 endif()
 
+execute_process(COMMAND git describe --tags --dirty --always
+                RESULT_VARIABLE USING_GIT
+                OUTPUT_VARIABLE LIBCOAP_PACKAGE_BUILD
+                OUTPUT_STRIP_TRAILING_WHITESPACE
+                ERROR_QUIET)
+if(NOT ${USING_GIT} EQUAL 0)
+  set(LIBCOAP_PACKAGE_BUILD ${PROJECT_VERSION})
+else()
+  set(LIBCOAP_PACKAGE_BUILD "${LIBCOAP_PACKAGE_BUILD}")
+endif()
+
+set(PACKAGE_URL "https://libcoap.net/")
+set(PACKAGE_NAME "${PROJECT_NAME}")
+set(PACKAGE_TARNAME "${PROJECT_NAME}")
+set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
+set(PACKAGE_VERSION "${PROJECT_VERSION}")
+set(PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
+set(LIBCOAP_PACKAGE_VERSION "${PACKAGE_VERSION}")
+set(LIBCOAP_PACKAGE_URL "${PACKAGE_URL}")
+set(LIBCOAP_PACKAGE_NAME "${PACKAGE_NAME}")
+set(LIBCOAP_PACKAGE_STRING "${PACKAGE_STRING}")
+set(LIBCOAP_PACKAGE_BUGREPORT "${PACKAGE_BUGREPORT}")
+
+message(STATUS "PACKAGE VERSION..................${PACKAGE_VERSION}")
+message(STATUS "PACKAGE BUILD....................${LIBCOAP_PACKAGE_BUILD}")
 message(STATUS "ENABLE_DTLS:.....................${ENABLE_DTLS}")
 message(STATUS "ENABLE_TCP:......................${ENABLE_TCP}")
+message(STATUS "ENABLE_CLIENT_MODE:..............${ENABLE_CLIENT_MODE}")
+message(STATUS "ENABLE_SERVER_MODE:..............${ENABLE_SERVER_MODE}")
 message(STATUS "ENABLE_DOCS:.....................${ENABLE_DOCS}")
 message(STATUS "ENABLE_EXAMPLES:.................${ENABLE_EXAMPLES}")
 message(STATUS "DTLS_BACKEND:....................${DTLS_BACKEND}")
@@ -364,47 +417,3 @@
 message(STATUS "WITH_MBEDTLS:....................${WITH_MBEDTLS}")
 message(STATUS "HAVE_LIBTINYDTLS:................${HAVE_LIBTINYDTLS}")
 message(STATUS "HAVE_LIBGNUTLS:..................${HAVE_LIBGNUTLS}")
-message(STATUS "HAVE_OPENSSL:....................${HAVE_OPENSSL}")
-message(STATUS "HAVE_MBEDTLS:....................${HAVE_MBEDTLS}")
-message(STATUS "COAP_EPOLL_SUPPORT:..............${COAP_EPOLL_SUPPORT}")
-message(STATUS "CMAKE_C_COMPILER:................${CMAKE_C_COMPILER}")
-message(STATUS "BUILD_SHARED_LIBS:...............${BUILD_SHARED_LIBS}")
-message(STATUS "CMAKE_BUILD_TYPE:................${CMAKE_BUILD_TYPE}")
-message(STATUS "CMAKE_SYSTEM_PROCESSOR:..........${CMAKE_SYSTEM_PROCESSOR}")
-
-set(PACKAGE_URL "https://libcoap.net/")
-set(PACKAGE_NAME "${PROJECT_NAME}")
-set(PACKAGE_TARNAME "${PROJECT_NAME}")
-set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
-set(PACKAGE_VERSION "${PROJECT_VERSION}")
-set(LIBCOAP_PACKAGE_VERSION "${PROJECT_VERSION}")
-set(LIBCOAP_PACKAGE_URL "${PACKAGE_URL}")
-set(LIBCOAP_PACKAGE_NAME "${PROJECT_NAME}")
-set(LIBCOAP_PACKAGE_STRING "TODO")
-set(LIBCOAP_PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
-set(PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
-set(top_srcdir "${CMAKE_CURRENT_LIST_DIR}")
-set(top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
-if(ENABLE_TCP)
-  set(COAP_DISABLE_TCP 0)
-else(ENABLE_TCP)
-  set(COAP_DISABLE_TCP 1)
-endif(ENABLE_TCP)
-
-# creates config header file in build directory
-configure_file(${CMAKE_CURRENT_LIST_DIR}/include/coap${LIBCOAP_API_VERSION}/coap.h.in
-               ${CMAKE_CURRENT_BINARY_DIR}/include/coap${LIBCOAP_API_VERSION}/coap.h)
-
-configure_file(${CMAKE_CURRENT_LIST_DIR}/cmake_coap_config.h.in
-               ${CMAKE_CURRENT_BINARY_DIR}/coap_config.h)
-
-configure_file(${CMAKE_CURRENT_LIST_DIR}/tests/test_common.h.in
-               ${CMAKE_CURRENT_LIST_DIR}/tests/test_common.h)
-
-#
-# sources
-#
-
-target_sources(
-  ${COAP_LIBRARY_NAME}
-  PRIVATE ${CMAKE_CURRENT_LIST_DIR}/src/address.c
