=== debian/changelog ===
libcoap3 (4.3.1-2) unstable; urgency=medium

  * [ff7e712] Rebuild patch queue from patch-queue branch
    Added patch:
    CVE-2023-30362-Fix-buffer-overflow-in-coap_send_internal.patch
    (Closes: #1040594)
  * [2d091bc] d/control: Update Standards-Version to 4.6.2
    No further changes needed.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 08 Jul 2023 13:07:15 +0200

libcoap3 (4.3.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * [67731af] Set upstream metadata fields: Repository.

  [ Carsten Schoenert ]
  * [99a9767] New upstream version 4.3.1
  * [3daaf3d] Rebuild patch queue from patch-queue branch
    Added patches:
    Modeline-Correct-vim-modline-syntax.patch
    Spelling-Fix-minor-spelling-and-typos.patch
    Dropped patch (applied upstream):
    pkg-config-Don-t-use-hard-coded-binary.patch
  * [c91abcf] d/control: Update some build dependencies
  * [b87ad73] d/control: Update Standards-Version to 4.6.1
    No further changes needed.
  * [baf2a70] d/u/metadata: Add some more data

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 28 Nov 2022 11:51:55 +0100
