=== debian/control ===
--- 
+++ 
@@ -5,16 +5,16 @@
 Uploaders:
  Carsten Schoenert <c.schoenert@t-online.de>,
 Build-Depends:
- asciidoc,
+ asciidoc-base,
  debhelper-compat (= 13),
  doxygen,
  exuberant-ctags,
  graphviz,
  libgnutls28-dev,
  libssl-dev,
- pkg-config,
+ pkgconf,
  xmlto,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: binary-targets
 Homepage: https://libcoap.net/
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/libcoap3
